

#include <GL/glut.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

static float alpha = 0;

void init(void) {

  glClearColor(0.0, 0.0, 0.0, 0.0);
  glShadeModel(GL_FLAT);
}


void display(void) {

  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1.0, 1.0, 1.0);
  glLoadIdentity();
  
  gluLookAt(5*cos(alpha), 5*sin(alpha), 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  glScalef(1.0, 2.0, 1.0);
  glutWireCube(1.0);
  glFlush();
}


void reshape(int w, int h) {

  glViewport(0, 0, (GLsizei) w, (GLsizei)h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
  glMatrixMode(GL_MODELVIEW);
}


void spinDisplay( void ) {

  alpha = alpha + 0.01;
  if (alpha > 360)
    alpha = 0;
  glutPostRedisplay();
}


void mouse( int button, int state, int x, int y ) {

  switch( button ) {
  case GLUT_LEFT_BUTTON:
    if (state == GLUT_DOWN) {
      glutIdleFunc(spinDisplay);
    }
    break;
  case GLUT_RIGHT_BUTTON:
    if (state == GLUT_DOWN) {
      glutIdleFunc(NULL);
    }
    break;
  default:
    break;
  }
}



int main(int argc, char** argv) {

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
  glutInitWindowSize(500, 500);
  glutInitWindowPosition(100, 100);
  glutCreateWindow(argv[0]);
  init();
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutMainLoop();

  return 0;
}


//EOF
