/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: ...
   co-programmer: ...
*/

//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY

#include "proto_singleton.h"

using namespace std;


/**
   \brief standard constructor
*/
ProtoSingleton::ProtoSingleton () 
{
   this->setClassName ("ProtoSingleton");

}

/**
   \brief the singleton reference to this class
*/
ProtoSingleton* ProtoSingleton::singletonRef = NULL;

/**
   \returns a Pointer to this Class
*/
ProtoSingleton* ProtoSingleton::getInstance(void)
{
  if (!ProtoSingleton::singletonRef)
    ProtoSingleton::singletonRef = new ProtoSingleton();
  return ProtoSingleton::singletonRef;
}

/**
   \brief standard deconstructor

*/
ProtoSingleton::~ProtoSingleton () 
{
  ProtoSingleton::singletonRef = NULL;

}
